ubuntu-location-service: com::ubuntu::location::service::Interface Class Reference

ubuntu-location-service .. An aggregating location service providing positioning and geocoding capabilities to applications.

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
com::ubuntu::location::service::Interface Class Referenceabstract

The Interface class models the primary interface to the location service. More...

`#include <interface.h>`

Collaboration diagram for com::ubuntu::location::service::Interface:

## Classes
struct | CreateSessionForCriteria
struct | Errors
struct | Properties

## Public Types
typedef std::shared_ptr< Interface > | Ptr

## Public Member Functions
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
virtual | ~Interface ()=default
virtual const core::Property< State > & | state () const =0
| The overall state of the service. More...
virtual core::Property< bool > & | does_satellite_based_positioning ()=0
| Whether the service uses satellite-based positioning. More...
virtual core::Property< bool > & | is_online ()=0
| Whether the overall service and its positioning engine is online or not. More...
virtual core::Property< bool > & | does_report_cell_and_wifi_ids ()=0
| Whether the engine and its providers/reporters do call home to report reference locations together with wifi and cell ids. More...
virtual core::Property< std::map< SpaceVehicle::Key, SpaceVehicle > > & | visible_space_vehicles ()=0
| All space vehicles currently visible. More...
virtual session::Interface::Ptr | create_session_for_criteria (const Criteria &criteria)=0
| Starts a new session for the given criteria. More...

## Static Public Member Functions
static const std::string & | path ()
| Queries the path that this object is known under. More...

## Protected Member Functions
| Interface ()=default

## Detailed Description

The Interface class models the primary interface to the location service.

Definition at line 47 of file interface.h.

## Member Typedef Documentation

## ◆ Ptr

typedef std::shared_ptr<Interface> com::ubuntu::location::service::Interface::Ptr

Definition at line 181 of file interface.h.

## Constructor & Destructor Documentation

## ◆ Interface() [1/2]

com::ubuntu::location::service::Interface::Interface | ( |  | ) |
| protecteddefault

## ◆ Interface() [2/2]

com::ubuntu::location::service::Interface::Interface | ( | const Interface & |  | ) |
| delete

## ◆ ~Interface()

virtual com::ubuntu::location::service::Interface::~Interface | ( |  | ) |
| virtualdefault

## Member Function Documentation

## ◆ create_session_for_criteria()

virtual session::Interface::Ptr com::ubuntu::location::service::Interface::create_session_for_criteria | ( | const Criteria & | criteria | ) |
| pure virtual

Starts a new session for the given criteria.

Exceptions

  std::runtime_error | in case of errors.

Parameters

  criteria | The client's requirements in terms of accuraccy and functionality

Returns
  A session instance.

## ◆ does_report_cell_and_wifi_ids()

virtual core::Property<bool>& com::ubuntu::location::service::Interface::does_report_cell_and_wifi_ids | ( |  | ) |
| pure virtual

Whether the engine and its providers/reporters do call home to report reference locations together with wifi and cell ids.

We consider this feature privacy sensitive and it defaults to false. The user has to explicitly opt-in into this feature.

Returns
  A setable/getable/observable property.

## ◆ does_satellite_based_positioning()

virtual core::Property<bool>& com::ubuntu::location::service::Interface::does_satellite_based_positioning | ( |  | ) |
| pure virtual

Whether the service uses satellite-based positioning.

Returns
  A setable/getable/observable property.

## ◆ is_online()

virtual core::Property<bool>& com::ubuntu::location::service::Interface::is_online | ( |  | ) |
| pure virtual

Whether the overall service and its positioning engine is online or not.

Returns
  A setable/getable/observable property.

## ◆ operator=()

Interface& com::ubuntu::location::service::Interface::operator= | ( | const Interface & |  | ) |
| delete

## ◆ path()

static const std::string& com::ubuntu::location::service::Interface::path | ( |  | ) |
| inlinestatic

Queries the path that this object is known under.

Definition at line 186 of file interface.h.

## ◆ state()

virtual const core::Property<State>& com::ubuntu::location::service::Interface::state | ( |  | ) | const
| pure virtual

The overall state of the service.

Returns
  a getable/observable property.

## ◆ visible_space_vehicles()

virtual core::Property<std::map<SpaceVehicle::Key, SpaceVehicle> >& com::ubuntu::location::service::Interface::visible_space_vehicles | ( |  | ) |
| pure virtual

All space vehicles currently visible.

The documentation for this class was generated from the following file:

- /build/location-service-git/src/location-service/include/location_service/com/ubuntu/location/service/interface.h